---
title: Document.mozSetImageElement()
slug: Web/API/Document/mozSetImageElement
tags:
  - API
  - DOM
  - DOM Reference
  - Method
  - Non-standard
  - Reference
---
<p>{{ ApiRef("DOM") }}{{ gecko_minversion_header("2.0") }}{{ non-standard_header() }}</p>

<p>The <code><strong>Document.mozSetImageElement()</strong></code> method changes the element being used as the CSS background for a background with a given background element ID.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>document</em>.mozSetImageElement(<em>imageElementId</em>, <em>imageElement</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><code>imageElementId</code> is a string indicating the name of an element that has been specified as a background image using the {{ cssxref("-moz-element") }} CSS function.</li>
 <li><code>imageElement</code> is the new element to use as the background corresponding to that image element string. Specify <code>null</code> to remove the background element.</li>
</ul>

<h2 id="Example">Example</h2>

<p>This example changes the background of a {{ HTMLElement("div") }} block each time the block is clicked by the user.</p>

<p><a href="/samples/domref/mozSetImageElement.html" title="https://developer.mozilla.org/samples/domref/mozSetImageElement.html">View this example live</a>.</p>

<pre class="brush: html">&lt;style type="text/css"&gt;
  #mybox {
    background-image: -moz-element(#canvasbg);
    text-align: center;
    width: 400px;
    height: 400px;
    cursor: pointer;
  }
&lt;/style&gt;
</pre>

<p>The CSS defined by the {{ HTMLElement("style") }} block above is used by our {{ HTMLElement("div") }} to use an element with the id "canvasbg" as its background.</p>

<pre class="brush: js">var c = 0x00;
function clicked() {
  var canvas = document.createElement("canvas");
  canvas.setAttribute("width", 100);
  canvas.setAttribute("height", 100);

  var ctx = canvas.getContext('2d');
  ctx.fillStyle = "#" + c.toString(16) + "0000";
  ctx.fillRect(25, 25, 75, 75);

  c += 0x11;
  if (c &gt; 0xff) {
    c = 0x00;
  }

  document.mozSetImageElement("canvasbg", canvas);
}
</pre>

<p>The code here is called each time the user clicks the {{ HTMLElement("div") }} element. It creates a new {{ HTMLElement("canvas") }} with the width and height set to 100 pixels, then draws into it a 50 by 50 pixel square. Each time the function is called, the square is a different color (its red component is increased each time), so each time the user clicks the element, the background is filled with a brighter and brighter pattern of red tiles.</p>

<p>Once the canvas is drawn, <code>document.mozSetImageElement()</code> is called to set the background for any CSS using the ID "canvasbg" as its background element ID to be our new canvas.</p>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.mozSetImageElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{ cssxref("-moz-element") }}</li>
</ul>
